CREATE FUNCTION [dbo].[FN_DLV_ATD_EXPLODE] (@Input NVARCHAR(MAX), @Separator NVARCHAR(100))
	RETURNS TABLE AS
	RETURN
	WITH
		E1(i) AS (SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1 UNION ALL SELECT 1),
		E2(i) AS (SELECT 1 FROM E1 a, E1 b),
		E6(i) AS (SELECT 1 FROM E2 a, E2 b, E2 c),
		Possibles(i) AS (SELECT 0 UNION ALL SELECT TOP (LEN(@Input) - LEN(@Separator)) ROW_NUMBER() OVER (ORDER BY (SELECT NULL)) FROM E6),
		Matches(i) AS (SELECT CASE p.i WHEN 0 THEN p.i + 1 ELSE p.i + LEN(@Separator) END FROM Possibles p WHERE (SUBSTRING(@Input, p.i, LEN(@Separator)) = @Separator OR p.i = 0))

		SELECT
			ItemNumber = ROW_NUMBER() OVER(ORDER BY m.i),
			Item = SUBSTRING(@Input, m.i, ISNULL(NULLIF(CHARINDEX(@Separator, @Input, m.i), 0) - m.i, 1000000))
		FROM Matches m;

